create function is_strictly_left_of(scalar_ anynonarray,
                                    range_ anyrange) returns boolean as
$$
BEGIN
    return lower(range_) is not null and scalar_ < lower(range_);
END
$$ immutable
   parallel safe
   strict language plpgsql;


create function is_strictly_right_of(range_ anyrange,
                                     scalar_ anynonarray) returns boolean as
$$
BEGIN
    return upper(range_) is null or upper(range_) > scalar_;
END
$$ immutable
   parallel safe
   strict language plpgsql;


create function is_strictly_left_of(scalar_ anynonarray,
                                    range_ anyrange) returns boolean as
$$
BEGIN
    return lower(range_) is not null and scalar_ < lower(range_);
END
$$ immutable
   parallel safe
   strict language plpgsql;


create function is_strictly_right_of(range_ anyrange,
                                     scalar_ anynonarray) returns boolean as
$$
BEGIN
    return upper(range_) is null or upper(range_) > scalar_;
END
$$ immutable
   parallel safe
   strict language plpgsql;


create operator << (
    leftarg = anynonarray,
    rightarg = anyrange,
    procedure = is_strictly_left_of,
    commutator = >>,


    )